import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.List;

public class ApplianceModelsDefinition {
    private String version;
    private List<Model> models;
    private ObjectMapper objectMapper;

    ApplianceModelsDefinition(){
        this.objectMapper = new ObjectMapper();
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public List<Model> getModels() {
        return models;
    }

    public void setModels(List<Model> models) {
        this.models = models;
    }

    public boolean importFromJSON(){
        try {
            ApplianceModelsDefinition applianceModelsDefinition;
            applianceModelsDefinition= objectMapper.readValue(new FileInputStream("ApplianceModels.json"), ApplianceModelsDefinition.class);
            this.version = applianceModelsDefinition.getVersion();
            this.models = applianceModelsDefinition.getModels();
            return true;
        } catch (JsonMappingException e) {
            throw new RuntimeException(e);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        } catch (JsonParseException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}

class Model {
    private String model;
    private String type;
    private List<Function> functions;

    Model(String name, String type){
        this.model = name;
        this.type = type;
    }
    Model(String name){
        this.model = name;
    }
    Model(){

    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public List<Function> getFunctions() {
        return functions;
    }

    public void setFunctions(List<Function> functions) {
        this.functions = functions;
    }
}

class Function {
    private String function;
    private int code;

    Function(String function, int code){
        this.function = function;
        this.code = code;
    }
    Function(){

    }

    public String getFunction() {
        return function;
    }

    public void setFunction(String function) {
        this.function = function;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }
}
