import com.fasterxml.jackson.core.JsonGenerationException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class RCU {
    private String name;
    private List<Appliances> appliances; // List of appliances.
    private ObjectMapper objectMapper;

    public RCU(String name) {
        this.name = name;
        this.appliances = new ArrayList<Appliances>();
        this.objectMapper = new ObjectMapper();
    }

    public void addAppliance(Appliances appliance) {
        appliances.add(appliance);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Appliances> getAppliances() {
        return appliances;
    }

    public void setAppliances(List<Appliances> appliances) {
        this.appliances = appliances;
    }

    public boolean exportToJSON(){
        objectMapper.enable(SerializationFeature.INDENT_OUTPUT); // Enable JSON pretty printing.
        try {
            objectMapper.writeValue(new FileOutputStream("rcu.json"), this);
            return true;
        } catch (JsonMappingException e) {
            throw new RuntimeException(e);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        } catch (JsonGenerationException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
